techco-app/src/main/java/com/oracle/cloud/demo/oe/web/BasketController.java
package com.oracle.cloud.demo.oe.web;

import com.oracle.cloud.demo.oe.entities.Order;
import com.oracle.cloud.demo.oe.sessions.CheckoutSessionBeanRemote;
import com.oracle.cloud.demo.oe.web.util.BasketItem;

import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

@Named("basket")
@SessionScoped
public class BasketController implements Serializable {
    private final List<BasketItem> products = new ArrayList<>();
    private BigDecimal total = BigDecimal.ZERO;

    @EJB
    protected CheckoutSessionBeanRemote checkoutBean;

    @Inject
    protected MyOrdersController myOrdersController;

    @Inject
    protected CustomersController customersController;

    public BigDecimal getTotal() {
        return total;
    }

    public List<BasketItem> getProducts() {
        return products;
    }

    public int getCount(){
        return products.size();
    }

    public void addItem(BasketItem bi) {
        BasketItem existingItem = null;
        for (BasketItem cartItem : products) {
            if (cartItem.getProduct().equals(bi.getProduct())) {
                existingItem = cartItem;
                break;
            }
        }
        if (existingItem != null) {
            existingItem.setQuantity(existingItem.getQuantity() + 1);

        } else {
            products.add(bi);
        }
        total = total.add(bi.getSubtotal());
    }

    public void addItems(List<BasketItem> basketItemsToAdd) {
        for (BasketItem p : basketItemsToAdd) {
            addItem(p);
        }
    }

    public void removeItem(BasketItem item) {
        products.remove(item);
        total = total.subtract(item.getSubtotal());
    }

    public void clearBasket() {
        products.clear();
        total = BigDecimal.ZERO;
    }

    public void loadCustomerInfo(){
    	//This is important!!
        String user = FacesContext.getCurrentInstance().getExternalContext().getRemoteUser();
        customersController.setCurrent(customersController.getCustomer(user));
        myOrdersController.setFilterByCustomerEmail(user);
    }

    public String prepareCheckout(){
        if (products.isEmpty()) {
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN, "Product list is empty. You must first add products to the basket.", ""));
            return "/shop/Basket";
        }
        return "/user/Checkout?faces-redirect=true";
    }

    public String checkout() {

        String user = FacesContext.getCurrentInstance().getExternalContext().getRemoteUser();
        Order order = checkoutBean.checkout(user, products);
        myOrdersController.setCurrent(order);
        clearBasket();

        return "/user/ViewLastPlacedOrder";
    }

    public String updateTotal(){
        total = BigDecimal.ZERO;
        for (BasketItem cartItem : products) {
            total = total.add(cartItem.getSubtotal());
        }
        return "Basket";
    }
}

techco-app/src/main/java/com/oracle/cloud/demo/oe/web/OrdersController.java
package com.oracle.cloud.demo.oe.web;

import com.oracle.cloud.demo.oe.entities.Order;
import com.oracle.cloud.demo.oe.sessions.OrdersFacadeRemote;
import com.oracle.cloud.demo.oe.web.util.JsfUtil;
import com.oracle.cloud.demo.oe.web.util.PaginationHelper;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import javax.faces.model.SelectItem;
import javax.inject.Named;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;

@Named("ordersController")
@SessionScoped
public class OrdersController implements Serializable {
    private Order current;
    private List<Order> items;
    private PaginationHelper pagination;
    private String filterByCustomerEmail;

    @EJB
    private OrdersFacadeRemote ejbFacade;

    @PostConstruct
    public void postConstruct() {
        setFilterByCustomerEmail(null);
    }

    public Order getCurrent() {
        if (current == null) {
            current = new Order();
        }
        return current;
    }

    public void setCurrent(Order order) {
        this.current = order;
    }

    public int getNumOfItemsFilter() {
        return getPagination().getPageSize();
    }

    public void setNumOfItemsFilter(int numOfItemsFilter) {
        getPagination().setPageSize(numOfItemsFilter);
        recreateModel();
    }

    private OrdersFacadeRemote getFacade() {
        ejbFacade.setFilterByCustomerEmail(filterByCustomerEmail);
        return ejbFacade;
    }

    public PaginationHelper getPagination() {
        if (pagination == null) {
            pagination = new PaginationHelper(5) {
                @Override
                public int getItemsCount() {
                    return getFacade().count();
                }

                @Override
                public List<Order> createPageModel() {
                    return new ArrayList(getFacade().findRange(new int[]{getPageFirstItem(), getPageFirstItem() + getPageSize()}));
                }
            };
        }
        return pagination;
    }

    public String prepareList() {
        recreateModel();
        return "List";
    }

    public String prepareView(Order order) {
    	// This is important!!!
        current = order;
        return "View";
    }

    public String prepareCreate() {
        current = new Order();
        return "Create";
    }

    public String create() {
        try {
            getFacade().create(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("OrdersCreated"));
            return prepareCreate();
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String prepareEdit(Order order) {
        current = order;
        return "Edit";
    }

    public String update() {
        try {
            getFacade().edit(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("OrdersUpdated"));
            return "View";
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String destroy(Order order) {
        current = order;
        performDestroy();
        if (getItems().size() <= 1) {
            pagination.previousPage();
        }
        recreateModel();
        return "List";
    }

    public String destroy() {
        return destroy(current);
    }

    private void performDestroy() {
        try {
            getFacade().remove(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("OrdersDeleted"));
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
        }
    }

    public List<Order> getItems() {
        if (items == null) {
            items = getPagination().createPageModel();
        }
        return items;
    }

    private void recreateModel() {
        items = null;
    }

    private void recreatePagination() {
        pagination = null;
    }

    public String next() {
        getPagination().nextPage();
        recreateModel();
        return "List";
    }

    public String previous() {
        getPagination().previousPage();
        recreateModel();
        return "List";
    }

    public SelectItem[] getItemsAvailableSelectMany() {
        return JsfUtil.getSelectItems(getFacade().findAll(), false);
    }

    public SelectItem[] getItemsAvailableSelectOne() {
        return JsfUtil.getSelectItems(getFacade().findAll(), true);
    }

    public Order getOrder(Long id) {
        return getFacade().find(id);
    }

    @FacesConverter(forClass = Order.class)
    public static class OrdersControllerConverter implements Converter {

        @Override
        public Object getAsObject(FacesContext facesContext, UIComponent component, String value) {
            if (value == null || value.length() == 0) {
                return null;
            }
            OrdersController controller = (OrdersController) facesContext.getApplication().getELResolver().
                    getValue(facesContext.getELContext(), null, "ordersController");
            return controller.getOrder(getKey(value));
        }

        Long getKey(String value) {
            Long key = Long.valueOf(value);
            return key;
        }

        String getStringKey(Long value) {
            StringBuilder sb = new StringBuilder();
            sb.append(value);
            return sb.toString();
        }

        @Override
        public String getAsString(FacesContext facesContext, UIComponent component, Object object) {
            if (object == null) {
                return null;
            }
            if (object instanceof Order) {
                Order o = (Order) object;
                return getStringKey(o.getOrderId());
            } else {
                throw new IllegalArgumentException("object " + object + " is of type " + object.getClass().getName() + "; expected type: " + Order.class.getName());
            }
        }
    }

    public void setFilterByCustomerEmail(String filterByCustomerEmail) {
        this.filterByCustomerEmail = filterByCustomerEmail;
    }

    public String getFilterByCustomerEmail() {
        return filterByCustomerEmail;
    }

    public void filter() {
        recreateModel();
        recreatePagination();
    }

    public void clearFilter() {
        setFilterByCustomerEmail(null);
        filter();
    }
}

techco-app/src/main/webapp/shared/adminheader.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html">

    <ui:composition>
        <div class="navbar topnavbar col-lg-12 col-md-12">
            <!-- top menu -->
            <h:form id="headerLinksForm">
                <a href="${facesContext.externalContext.requestContextPath}/admin" class="navbar-brand logo">
                    <h:graphicImage alt="no image available" library="default" name="img/logo.png"/>
                </a>
                <ui:param name="view" value="#{facesContext.viewRoot.viewId}"/>
                <!--nav-->
                <ul class="nav navbar-nav topnavright">
                    <h:panelGroup rendered="#{not empty request.remoteUser}">
                        <li>
                            <h:commandLink action="#{myOrdersController.prepareList}" value="#{logoutController.userDisplayName}"/>
                        </li>
                        <li>
                            <h:commandLink styleClass="logoutLink" action="#{logoutController.logout}" value="Log Out"/>
                        </li>
                    </h:panelGroup>
                </ul>
                <ul class="nav navbar-nav topnav">
                    <li class="dropdown #{view == '/index.xhtml' ? 'active' : ''}">
                        <h:link outcome="/admin/customers/List" value="Customers" />
                    </li>
                    <li class="dropdown #{(view == '/shop/BrowseProducts.xhtml' or view == '/shop/BrowseCategories.xhtml') ? 'active' : ''}">
                        <h:link outcome="/admin/orders/List" value="Orders" />
                    </li>
                    <li class="dropdown #{view == '/shop/Basket.xhtml' ? 'active' : ''}">
                        <h:link outcome="/admin/productInformation/List" value="Products"/>
                    </li>
                    <li class="dropdown #{view == '/user/MyOrders.xhtml' ? 'active' : ''}">
                        <h:link outcome="/admin/orderItems/List" value="Orders Items"/>
                    </li>
                </ul>
                <!--/nav-->
            </h:form>
            <!-- end menu -->
        </div>
    </ui:composition>

</html>

techco-app/src/main/webapp/shared/footer.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html">

    <ui:composition>
        <div class="row innerfooter">
            <div class="col-lg-2 col-md-2 col-sm-6 col-lg-offset-1 col-md-offset-0">
                <div class="widget">
                    <h:outputText styleClass="footerHeader" value="About Us"/>
                    <ul class="regular" style="padding-top: 10px">
                        <li><a href="#">About our site</a></li>
                        <li><a href="#">Customer testimonials</a></li>
                        <li><a href="#">Press releases</a></li>
                        <li><a href="#">Careers</a></li>
                        <li><a href="#">Sitemap</a></li>
                    </ul>
                </div>
            </div>
            <div class="col-lg-2 col-md-2 col-sm-6">
                <div class="widget">
                    <h:outputText styleClass="footerHeader" value="Shopping"/>
                    <ul class="regular" style="padding-top: 10px">
                        <li><a href="#">Gift Certificates</a></li>
                        <li><a href="#">Search for events</a></li>
                        <li><a href="#">Special offers</a></li>
                        <li><a href="#">Our products</a></li>
                        <li><a href="#">On sale</a></li>
                    </ul>
                </div>
            </div>
            <div class="col-lg-2 col-md-2 col-sm-6">
                <div class="widget">
                    <h:outputText styleClass="footerHeader" value="Account"/>
                    <ul class="regular" style="padding-top: 10px">
                        <li><a href="#">Sign in</a></li>
                        <li><a href="#">Register</a></li>
                        <li><a href="#">Forgot Password</a></li>
                        <li><a href="#">Your account</a></li>
                    </ul>
                </div>
            </div>
            <div class="col-lg-2 col-md-3 col-sm-6">
                <div class="widget">
                    <h:outputText styleClass="footerHeader" value="Help"/>
                    <ul class="regular" style="padding-top: 10px">
                        <li><a href="#">Shipping Rates Policy</a></li>
                        <li><a href="#">Returns &amp; Replacements</a></li>
                        <li><a href="#">Terms &amp; Conditions</a></li>
                        <li><a href="#">Privacy Statement</a></li>
                        <li><a href="#">Contact us</a></li>
                    </ul>
                </div>
            </div>
            <div class="col-lg-2 col-md-3 col-sm-12">
                <div id="builtWithCloud" class="widget">
                    <h:graphicImage alt="no image available" library="default" name="img/built_with_cloud.png"/>
                </div>
            </div>
        </div>
        <div class="row verybottom">
            <h:panelGrid styleClass="verybottompg" columnClasses="verybottompg1, verybottompg2" columns="2">
                <h:panelGroup>
                    <h:outputText styleClass="verybottomtext" value="&copy; Oracle Corporation 2014 - All right reserved"/>
                </h:panelGroup>
                <h:panelGroup>
                    <a href="http://www.ateam-oracle.com/">Designed by the FMW ATEAM</a>
                </h:panelGroup>
            </h:panelGrid>
        </div>
    </ui:composition>

</html>

techco-app/src/main/webapp/shared/header.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html">

    <ui:composition>
        <div class="navbar topnavbar col-lg-12 col-md-12">
            <!-- top menu -->
            <h:form id="headerLinksForm">
                <h:link class="navbar-brand logo" outcome="/index" value="">
                    <h:graphicImage alt="no image available" library="default" name="img/logo.png"/>
                </h:link>
                <ui:param name="view" value="#{facesContext.viewRoot.viewId}"/>
                <!--nav-->
                <ul class="nav navbar-nav topnavright">
                    <h:panelGroup rendered="#{not empty request.remoteUser}">
                        <li>
                            <h:commandLink action="#{myOrdersController.prepareList}" value="#{logoutController.userDisplayName}"/>
                        </li>
                        <li>
                            <h:commandLink styleClass="logoutLink" action="#{logoutController.logout}" value="Log Out"/>
                        </li>
                    </h:panelGroup>
                </ul>
                <ul class="nav navbar-nav topnav">
                    <li class="dropdown #{view == '/index.xhtml' ? 'active' : ''}">
                        <h:link outcome="/index" value="Home"/>
                    </li>
                    <li class="dropdown #{(view == '/shop/BrowseProducts.xhtml' or view == '/shop/BrowseCategories.xhtml') ? 'active' : ''}">
                        <h:link outcome="/shop/BrowseCategories" value="Browse"/>
                    </li>
                    <li class="dropdown #{view == '/shop/Basket.xhtml' ? 'active' : ''}">
                        <h:link outcome="/shop/Basket" value="Cart (#{basket.count})"/>
                    </li>
                    <li class="dropdown #{view == '/user/MyOrders.xhtml' ? 'active' : ''}">
                        <h:commandLink action="#{myOrdersController.prepareList}" value="My Orders"/>
                    </li>
                </ul>
                <!--/nav-->
            </h:form>
            <!-- end menu -->
        </div>
    </ui:composition>

</html>

techco-app/src/main/webapp/shared/pagination.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:h="http://java.sun.com/jsf/html">

    <ui:composition>
        <h:commandButton type="submit"
                         action="#{controller.previous}"
                         value="#{bundle.Previous} #{controller.pagination.pageSize}"
                         styleClass="pagCounterIncr btn btn-flat}"
                         rendered="#{controller.pagination.hasPreviousPage}">&nbsp;</h:commandButton>
        <h:outputText styleClass="pagCounter"
                      value="#{controller.pagination.pageFirstItem + 1} ... #{controller.pagination.pageLastItem + 1} of #{controller.pagination.itemsCount}"/>&nbsp;
        <h:commandButton type="submit"
                         action="#{controller.next}"
                         value="#{bundle.Next} #{controller.pagination.pageSize}"
                         styleClass="pagCounterIncr btn btn-flat}"
                         rendered="#{controller.pagination.hasNextPage}"/>
    </ui:composition>

</html>